﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TestCoverageAnalysisTool
{
  public partial class MainForm : Form
  {
    public int RecursionLevel { get; set; }

    public MainForm()
    {
      InitializeComponent();
    }

    private void listBox1_MouseDoubleClick(object sender, MouseEventArgs e)
    {
      int index = listBox1.IndexFromPoint(e.Location);
      if (index != ListBox.NoMatches)
      {
        string sv = listBox1.Items[index].ToString();

        var f = new TreeInterpreterForm();
        f.TreeName = sv;
        f.LoadTreeFromFile();

        f.Show();
      }

    }

    private void button1_Click(object sender, EventArgs e)
    {
      DirectoryInfo dirInfo = new DirectoryInfo("tests");

      foreach (FileInfo file in dirInfo.GetFiles())
      {
        file.Delete();
      }

      listBox1.Items.Clear();
      RecursionLevel = comboBox1.SelectedIndex;

      /* var adjacencyMatrix = new Matrix(new[,]
      {
          {0, 1, 0, 0, 0, 0, 0, 0},
          {0, 0, 1, 0, 0, 0, 0, 0},
          {0, 0, 0, 1, 0, 0, 1, 0},
          {0, 0, 0, 0, 1, 0, 0, 0},
          {0, 0, 0, 0, 0, 1, 0, 0},
          {0, 0, 0, 0, 0, 0, 1, 0},               
          {0, 0, 0, 0, 0, 0, 0, 1},              
          {0, 0, 0, 0, 0, 0, 0, 0}
      });

      var nodeNames = new List<string>()
      {
          "A",
          "B()",
          "C",
          "D",
          "E",
          "F()",
          "G",
          "H"
      };

      var routes = Program.GenerateTests(adjacencyMatrix, nodeNames, new List<string>() {"B"}, 1);*/

      //Генерация матриц смежности и списков узлов
      Program.GenerateMatricesAndVarLists();

      var adjacencyMatrix = Program.GetMatrixFromMtrFile(@"matrices\yyparse.dot.mtr");
      var nodeNames = Program.GetNodeNamesFromLstFile(@"matrices\yyparse.dot.lst");

      var procNames =
          Directory.GetFiles("matrices")
              .Where(fn => fn.EndsWith(".dot.mtr"))
              .Select(fn => Path.GetFileName(fn).Replace(".dot.mtr", ""))
              .ToList();

      //Уровень раскрытия функций
      var depth = Convert.ToInt32(comboBox1.SelectedItem);

      //Генерация тестов
      var tests = Program.GenerateTests(adjacencyMatrix, nodeNames, procNames, depth);
      //var routes = Program.GenerateTests(adjacencyMatrix, nodeNames, procNames, 2);

      var testsNames =
            Directory.GetFiles("tests")
                .Select(fn => Path.GetFileName(fn).Replace(".TRE", ""))
                .ToList();

      //Заполнение списка тестов на форме для последующего просмотра визуализатором
      foreach (var test in testsNames)
      {
        listBox1.Items.Add(test);
      }

    }

    private void button2_Click(object sender, EventArgs e)
    {
      DirectoryInfo dirInfo = new DirectoryInfo("tests");

      foreach (FileInfo file in dirInfo.GetFiles())
      {
        file.Delete();
      }

      listBox1.Items.Clear();
    }

  }
}
