﻿using System;
using System.Linq;
using System.Text;

namespace TestCoverageAnalysisTool
{
    public class NodeName : IEquatable<NodeName>
    {
        public String FunctionName { get; set; }

        public String Name { get; set; }

        public Guid ID { get; set; }

        public NodeName()
        {
            ID = Guid.NewGuid();
        }

        public NodeName(string funcName, string name)
        {
            ID = Guid.NewGuid();

            FunctionName = funcName;
            Name = name;
        }

        public bool Equals(NodeName other)
        {
            return other.FunctionName == FunctionName && other.Name == Name && other.ID == ID;
        }

        public override int GetHashCode()
        {
            return FunctionName.GetHashCode() ^ Name.GetHashCode();
        }

        public override string ToString()
        {
            return String.Format("{0} - {1}", FunctionName, Name);
        }
    }
}
