using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TestCoverageAnalysisTool
{

  class Program
  {

    public static int i, j, k, kol;
    public struct uzel
    {
      public int nom;
      public int ki;
      public int kj;
    };
    public static uzel n = new uzel();
    static void vkl(Stack vst, uzel n)
    {
      vst.Push(n);
    }
    static void iskl(Stack vst)
    {
      if (vst == null)
        Console.WriteLine(" !");
      else
        n = (uzel)vst.Pop();
    }

    //    
    public static List<ValueTypedList<String>> SearchPaths(Matrix adjMatrix)
    {
      List<ValueTypedList<String>> paths = new List<ValueTypedList<String>>();

      int dimension = adjMatrix.Dimension;

      Stack vstek = new Stack();
      int beg, en, x, i1, i2;
      uzel y1 = new uzel();
      bool[] nov = new bool[dimension + 1];
      int[,] p = new int[dimension, dimension + 1];
      int[] m = new int[dimension + 1];

      //        
      for (i = 0; i < dimension; i++)
      {
        p[i, 0] = i;
        k = 1;
        for (j = 0; j < dimension; j++)
          if (adjMatrix[i, j] != 0)
          {
            p[i, k] = j;
            k++;
          }
        p[i, k] = 10000;
      }

      Console.WriteLine(" :");
      for (i = 0; i < dimension; i++)
      {
        k = 0;
        while (p[i, k] != 10000)
        {
          Console.Write(" {0}", p[i, k]);
          k++;
        }
        Console.WriteLine();
      }

      beg = 0;
      en = dimension - 1;
      //  
      for (i = 0; i < dimension; i++)
      {
        nov[i] = true;
        m[i] = 0;
      }
      nov[dimension] = false;
      x = 1;         //  
      m[1] = beg;
      i1 = 2;
      y1.nom = beg; //  nom  y1
      y1.ki = beg;  //    . 
      y1.kj = 0;  //      
      vkl(vstek, y1);
      kol = 1;       //   
      nov[beg] = false;
      nov[en] = false;
      i = beg;
      j = 0;
      //     
      Console.WriteLine("  :");
      while (kol != 0)
      {
        do
        {
          j++;
          if (p[i, j] == en)
          {
            ValueTypedList<String> a = new ValueTypedList<String>();
            Console.Write("  - {0} -", x);
            x++;
            for (i2 = 1; i2 < i1; i2++)
            {
              Console.Write(" {0}", m[i2]);
              a.Add(m[i2].ToString());
            }
            Console.WriteLine(" {0}", en);
            a.Add(en.ToString());
            paths.Add(a);
          }
        }
        while ((p[i, j] != 10000) && (!nov[p[i, j]]));
        if (p[i, j] != 10000)
          if (nov[p[i, j]])
          {
            y1.ki = i;
            y1.kj = j;
            i = p[i, j];
            y1.nom = i;
            vkl(vstek, y1);
            j = 0;
            kol++;
            nov[i] = false;
            m[i1] = i;
            i1++;
          }

        if (p[i, j] == 10000)
        {
          kol--;
          if (kol != 0)
          {
            iskl(vstek);
            i = n.ki;
            j = n.kj;
            i1--;
            m[i1] = 0;
            nov[n.nom] = true;
          }
        }
      }
      return paths;
    }

    // ()  
    public static Matrix GetPredominatorAdjMatrix(int dimension, Matrix adjacencyMatrix, Matrix dominatorsMatrix, Matrix initMatrix)
    {
      while (true)
      {
        var prevMatrix = new Matrix(dominatorsMatrix);

        PredomMatrixIteration(dimension, adjacencyMatrix, dominatorsMatrix, initMatrix);

        if (dominatorsMatrix.Equals(prevMatrix))
        {
          break;
        }
      }

      var domAdjMatrix = new Matrix(dominatorsMatrix.Dimension);

      for (int i = 1; i < dominatorsMatrix.Dimension; i++)
      {
        for (int j = i - 1; j >= 0; j--)
        {
          if (dominatorsMatrix[i, j] == 1)
          {
            domAdjMatrix[i, j] = 1;
            break;
          }
        }
      }

      return domAdjMatrix;
    }

    //   
    public static Matrix GetPostdominatorAdjMatrix(int dimension, Matrix adjacencyMatrix, Matrix dominatorsMatrix, Matrix initMatrix)
    {
      var newAdjMatrix = adjacencyMatrix.Transpose();
      newAdjMatrix = newAdjMatrix.HorizontalMapping();
      newAdjMatrix = newAdjMatrix.VerticalMapping();

      var domAdjMatrix = GetPredominatorAdjMatrix(dimension, newAdjMatrix, dominatorsMatrix, initMatrix);

      return domAdjMatrix;
    }

    // 
    public static List<ValueTypedList<String>> GenerateTests(Matrix mainFuncMatrix, List<string> mainFuncNodeNames, List<string> procNames, int depth)
    {
      #region     
      var procPattern = "(";

      foreach (var procName in procNames)
      {
        if (procName != "yyparse" && procName != "Parser")
        {
          procPattern += procName + "|";
        }
      }

      procPattern = procPattern.Trim('|');

      procPattern += ")";

      var nodeColl = new NodeNameCollection(mainFuncNodeNames, "");

      var mainTree = new Tree(mainFuncMatrix, nodeColl);

      //if (depth != 0)
      for (int i = 0; i <= depth; i++)
      {
        var toReplace = new List<Tuple<NodeName, Tree>>();

        foreach (var treeNode in mainTree.Keys)
        {
          var nodeLabel = treeNode.Key.Name;
          var node = treeNode.Value;

          var procName = !String.IsNullOrEmpty(GetFunctions(nodeLabel, procPattern).FirstOrDefault()) ? GetFunctions(nodeLabel, procPattern).FirstOrDefault().Trim(' ') : String.Empty;

          if (procName != null && procNames.Contains(procName) && node.Depth == i)
          {
            try
            {
              Tree procTree = GetTreeByProcName(procName);

              toReplace.Add(new Tuple<NodeName, Tree>(treeNode.Key, procTree));
            }
            catch (Exception)
            {

            }
          }
        }

        foreach (var tuple in toReplace)
        {
          mainTree[tuple.Item1].ReplaceByTree(tuple.Item2);
        }
      }

      #endregion

      NodeNameCollection contents;

      //       
      Matrix adjacencyMatrix = mainTree.GetAdjMatrix(out contents);
      var routes2 = SearchPaths(adjacencyMatrix);

      int dimension = adjacencyMatrix.Dimension;
      /*
      //    
      Matrix dominatorsMatrix = GetInitDominatorsMatrix(dimension);
      Matrix initMatrix = Matrix.GetIdentityMatrix(dimension);
      Matrix predomAdjMatrix = GetPredominatorAdjMatrix(dimension, adjacencyMatrix, dominatorsMatrix, initMatrix);
      Matrix transposedPredomMatrix = predomAdjMatrix.Transpose();
      Matrix postdomAdjMatrix = GetPostdominatorAdjMatrix(dimension, adjacencyMatrix, dominatorsMatrix, initMatrix);
      Matrix transposedPostdomMatrix = postdomAdjMatrix.Transpose();

      //  
      Matrix basicBlockDominatorGraph = Matrix.Sign(Matrix.MatrixAddition(transposedPredomMatrix,
        transposedPostdomMatrix.HorizontalMapping().VerticalMapping()));

      //     
      Matrix reachabilityMatrix = Matrix.GetReachabilityMatrix(basicBlockDominatorGraph);

      //      
      Matrix strongConnectivityMatrix =
        Matrix.GetStrongConnectivityMatrix(reachabilityMatrix);

      //   
      var scBlocks = GetStronglyConnectedComponentsList(strongConnectivityMatrix);

      //       
      Matrix superBlockDominatorGraph = GetAdjMatrixForStronglyConnectedComponents(basicBlockDominatorGraph, scBlocks);

      Console.WriteLine("   :");
      for (int i = 0; i < scBlocks.Count; i++)
      {
        Console.Write("{0} ", i);
        for (int j = 0; j < scBlocks[i].Count; j++)
        {
          Console.Write("{0} ", scBlocks[i][j]);
        }
        Console.WriteLine();
      }
       
      //            .   
      
      var routes = SearchPaths(superBlockDominatorGraph);
       */

      var pattern = @"MARK\s{0,2}\(.*\)\s{0,2}=\s{1,2}\S*";

      List<ValueTypedList<string>> newRoutes = new List<ValueTypedList<string>>();

      for (int i = 0; i < routes2.Count; i++)
      {
        ValueTypedList<string> route = new ValueTypedList<string>();
        for (int j = 0; j < routes2[i].Count; j++)
        {
          String node = contents.Items[Convert.ToInt32(routes2[i][j])].ToString();
          route.Add(node);
        }
        newRoutes.Add(route);
      }

      var nodesWithNewNode = newRoutes.FindAll(l => l.Any(i => Regex.IsMatch(i, pattern))).ToList();

      List<ValueTypedList<string>> tests = new List<ValueTypedList<string>>();
      List<String> dontAdd = new List<string>();
      dontAdd.Add("");
      for (int i = 0; i < nodesWithNewNode.Count; i++)
      {
        ValueTypedList<string> test = new ValueTypedList<string>();
        for (int j = 0; j < nodesWithNewNode[i].Count; j++)
        {
          String mark = GetMark(nodesWithNewNode[i][j]);
          if (mark != String.Empty)
            for (int k=0; k < GetConstructFromMark(mark).Count; k++)
              if (GetConstructFromMark(mark)[k] != "")
              test.Add(GetConstructFromMark(mark)[k]);
        }
        if (test.Any())
        tests.Add(test);
      }

      List<ValueTypedList<String>> uniqueTests = new List<ValueTypedList<String>>();

      foreach (var item in tests)
      {
        if (!uniqueTests.Contains(item))
          uniqueTests.Add(item);
      }

      int x = 1;
      for (int i = 0; i < uniqueTests.Count; i++)
      {
        using (StreamWriter file = new StreamWriter(String.Format(@"tests\{0}.TRE", x)))
        {
          for (int j = 0; j < uniqueTests[i].Count; j++)
          {
            file.WriteLine(uniqueTests[i][j]);
          }
        }
        x++;
      }

      return routes2;
    }

    //      "MARK (<node_name>) = <mark_name>;"
    public static String GetMark(string line)
    {
      String mark = String.Empty;

      mark = line.IndexOf("MARK") > -1 && line.IndexOf("==") == -1 ? line.Substring(line.IndexOf(" = ") + 3).TrimEnd(';').Trim(' ') : String.Empty;

      return mark;
    }

    public static List<string> GetConstructFromMark(string mark)
    {
      List<String> construct = new List<string>();

      switch (mark)
      {
        case "DO":
        construct.Add("do from 1 to 5 index i");
        construct.Add("while i<>j");
        construct.Add("enddo");
        break;
        case "RULE":
        construct.Add("");
        break;
        case "STATEMENTS":
        construct.Add("");
        break;
        case "MAP":
        construct.Add("map 1 to a");
        break;
        case "PROCUS":
        construct.Add("proc proc_name");
        construct.Add("proc return");
        construct.Add("endproc");
        break;
        default:
        construct.Add("");
        break;
      }

      return construct;
    }

    //     
    public static string MarkByIdentifier(int identifier)
    {
      switch (identifier)
      {
        case 256:
        return "RULE";
        case 255:
        return "CONST";
        case 254:
        return "VAR";
        case 253:
        return "SELECT";
        case 252:
        return "SLICE";
        case 251:
        return "PROC";
        case 250:
        return "OP1";
        case 249:
        return "OP2";

        case 248:
        return "STATEMENTS";

        case 247:
        return "MAP";
        case 246:
        return "OVERLAY";
        case 245:
        return "CLEARM";

        case 244:
        return "IF";

        case 243:
        return "CASEOF";
        case 242:
        return "SELECTOR";
        case 241:
        return "CASEOTHER";

        case 240:
        return "DO";
        case 239:
        return "FROM";
        case 238:
        return "TO";
        case 237:
        return "BY";
        case 236:
        return "WHILE";

        case 235:
        return "USERULENEST";
        case 234:
        return "USERULE";

        case 233:
        return "CONVWIN";
        case 232:
        return "CONVWINNO";

        case 231:
        return "RETURN";
        case 230:
        return "CAST";
        case 229:
        return "INDEX";
        case 228:
        return "SEL";
        case 227:
        return "USECOMP";
        case 226:
        return "SQL";
        case 225:
        return "PROCUS";
        case 224:
        return "PROCEDURES";
        case 223:
        return "CALLUS";
        case 222:
        return "EXEC";
        case 221:
        return "AGGREGATE";
        case 220:
        return "POST";
        case 219:
        return "EVENT";
        case 218:
        return "SKIP";
        case 217:
        return "CONVREP";

        case 216:
        return "OPEN";
        case 215:
        return "PRINT";
        case 214:
        return "CLOSE";
        case 213:
        return "BOOL_CONST";
        case 212:
        return "MAPG";

        case 211:
        return "HILO";

        case 210:
        return "USERULEDETACH";
        case 209:
        return "INSTANCE";

        case 208:
        return "TRUNC";

        case 207:
        return "SELDBCS";
        case 206:
        return "SELMIXED";

        case 205:
        return "NEXTITER";

        case 204:
        return "PROPERTIES";
        case 203:
        return "METHODSELECT";

        case 202:
        return "TRANSACTION";

        case 201:
        return "CONVREPSTART";
        case 200:
        return "CONVREPEND";
        case 199:
        return "SECTION";
        case 198:
        return "SUBHEADER";
        case 197:
        return "PRINTER";

        case 196:
        return "MAPVIEW";

        case 195:
        return "TERMINAL";
        case 194:
        return "STARTTIME";
        case 193:
        return "STARTINTERVAL";
        case 192:
        return "USERULEINIT";

        case 191:
        return "PRECOUNT";
        case 190:
        return "CONVREPOFF";
        case 189:
        return "USEPRECOUNT";
        case 188:
        return "INIT";
        case 187:
        return "BAD";
        case 186:
        return "CLEAR_GLOBAL";
        case 185:
        return "PROC_RETURN";
        case 184:
        return "SAVED_VAR";
        case 183:
        return "TEMPVIEWNODE";
        case 182:
        return "PICK";

        case 181:
        return "SIDE_EFFECT";

        case 180:
        return "NEW";
        case 179:
        return "LISTENER";

        case 178:
        return "COMMENT";
        case 177:
        return "DCLCURSOR";
        case 176:
        return "FETCH";
        case 175:
        return "SQLOPEN";
        case 174:
        return "SQLCLOSE";

        case 173:
        return "SET_SYMBOL";

        case 172:
        return "TRACENODE";

        case 171:
        return "PRE_CHANGE";
        case 170:
        return "POST_CHANGE";

        case 169:
        return "CAST_TO_DATA_OBJECT";

        case 168:
        return "APPEND";
        case 167:
        return "MAP_VC_LEN";

        case 166:
        return "SLICE_STRING";
        case 165:
        return "COB_COND";
        case 164:
        return "VARCHAR_LEN";

        case 163:
        return "PARA";
        case 162:
        return "GOTO";
        case 161:
        return "PERFORM";
        case 160:
        return "BLOCKS";
        case 159:
        return "BLOCK";
        case 158:
        return "EXIT_BLOCK";
        case 157:
        return "USERULELINK";
        case 156:
        return "USERULEXCTL";
        case 155:
        return "SYNT_PROC";

        case 154:
        return "CLEAR_CHAR";

        case 153:
        return "CONVERT";

        case 152:
        return "REFERENCE";
        default:
        return "";
      }
    }

    //     
    public static int IdentifierByMark(string mark)
    {
      switch (mark)
      {
        case "RULE":
        return 256;
        case "CONST":
        return 255;
        case "VAR":
        return 254;
        case "SELECT":
        return 253;
        case "SLICE":
        return 252;
        case "PROC":
        return 251;
        case "OP1":
        return 250;
        case "OP2":
        return 249;

        case "STATEMENTS":
        return 248;

        case "MAP":
        return 247;
        case "OVERLAY":
        return 246;
        case "CLEARM":
        return 245;

        case "IF":
        return 244;

        case "CASEOF":
        return 243;
        case "SELECTOR":
        return 242;
        case "CASEOTHER":
        return 241;

        case "DO":
        return 240;
        case "FROM":
        return 239;
        case "TO":
        return 238;
        case "BY":
        return 237;
        case "WHILE":
        return 236;

        case "USERULENEST":
        return 235;
        case "USERULE":
        return 234;

        case "CONVWIN":
        return 233;
        case "CONVWINNO":
        return 232;

        case "RETURN":
        return 231;
        case "CAST":
        return 230;
        case "INDEX":
        return 229;
        case "SEL":
        return 228;
        case "USECOMP":
        return 227;
        case "SQL":
        return 226;
        case "PROCUS":
        return 225;
        case "PROCEDURES":
        return 224;
        case "CALLUS":
        return 223;
        case "EXEC":
        return 222;
        case "AGGREGATE":
        return 221;
        case "POST":
        return 220;
        case "EVENT":
        return 219;
        case "SKIP":
        return 218;
        case "CONVREP":
        return 217;

        case "OPEN":
        return 216;
        case "PRINT":
        return 215;
        case "CLOSE":
        return 214;
        case "BOOL_CONST":
        return 213;
        case "MAPG":
        return 212;

        case "HILO":
        return 211;

        case "USERULEDETACH":
        return 210;
        case "INSTANCE":
        return 209;

        case "TRUNC":
        return 208;

        case "SELDBCS":
        return 207;
        case "SELMIXED":
        return 206;

        case "NEXTITER":
        return 205;

        case "PROPERTIES":
        return 204;
        case "METHODSELECT":
        return 203;

        case "TRANSACTION":
        return 202;

        case "CONVREPSTART":
        return 201;
        case "CONVREPEND":
        return 200;
        case "SECTION":
        return 199;
        case "SUBHEADER":
        return 198;
        case "PRINTER":
        return 197;

        case "MAPVIEW":
        return 196;

        case "TERMINAL":
        return 195;
        case "STARTTIME":
        return 194;
        case "STARTINTERVAL":
        return 193;
        case "USERULEINIT":
        return 192;

        case "PRECOUNT":
        return 191;
        case "CONVREPOFF":
        return 190;
        case "USEPRECOUNT":
        return 189;
        case "INIT":
        return 188;
        case "BAD":
        return 187;
        case "CLEAR_GLOBAL":
        return 186;
        case "PROC_RETURN":
        return 185;
        case "SAVED_VAR":
        return 184;
        case "TEMPVIEWNODE":
        return 183;
        case "PICK":
        return 182;

        case "SIDE_EFFECT":
        return 181;

        case "NEW":
        return 180;
        case "LISTENER":
        return 179;

        case "COMMENT":
        return 178;
        case "DCLCURSOR":
        return 177;
        case "FETCH":
        return 176;
        case "SQLOPEN":
        return 175;
        case "SQLCLOSE":
        return 174;

        case "SET_SYMBOL":
        return 173;

        case "TRACENODE":
        return 172;

        case "PRE_CHANGE":
        return 171;
        case "POST_CHANGE":
        return 170;

        case "CAST_TO_DATA_OBJECT":
        return 169;

        case "APPEND":
        return 168;
        case "MAP_VC_LEN":
        return 167;

        case "SLICE_STRING":
        return 166;
        case "COB_COND":
        return 165;
        case "VARCHAR_LEN":
        return 164;

        case "PARA":
        return 163;
        case "GOTO":
        return 162;
        case "PERFORM":
        return 161;
        case "BLOCKS":
        return 160;
        case "BLOCK":
        return 159;
        case "EXIT_BLOCK":
        return 158;
        case "USERULELINK":
        return 157;
        case "USERULEXCTL":
        return 156;
        case "SYNT_PROC":
        return 155;

        case "CLEAR_CHAR":
        return 154;

        case "CONVERT":
        return 153;

        case "REFERENCE":
        return 152;
        default:
        return 0;
      }
    }

    //         ,    dot-
    public static void GenerateMatricesAndVarLists()
    {
      DirectoryInfo dir = new DirectoryInfo("src");
      FileInfo[] files = dir.GetFiles();
      List<string> filesName = new List<string>();
      List<string> uniqueTests = new List<string>();

      foreach (FileInfo f in files)
      {
        string title = f.Name;
        byte[,] CFGMatrix = Parser(title);
        using (StreamWriter file = new StreamWriter(String.Format(@"matrices\{0}.mtr", title)))
        {
          for (int i = 0; i < CFGMatrix.GetLength(0); i++)
          {
            for (int j = 0; j < CFGMatrix.GetLength(1); j++)
              file.Write(CFGMatrix[i, j]);
            file.WriteLine();
          }

        }
        filesName.Add(title.Replace(".dot", ""));
        uniqueTests.Add(title);
      }
    }

    //  ,       .   dot-         (, __N1 -> __N2;)
    private static int SecondNumberPosition(string str)
    {
      List<string> counts = new List<string> { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9" };
      int pos = 0;
      bool isNumber = false;
      int i = 0;
      for (int k = 0; k < str.Length; k++)
      {
        if (counts.Contains(str[k].ToString()) && isNumber == false)
        {
          isNumber = true;
          i++;
        }
        else if (!counts.Contains(str[k].ToString()) && isNumber)
        {
          isNumber = false;
        }
        if (i == 2)
        {
          pos = k;
          break;
        }
      }
      return pos;
    }

    //  ,       .   dot-         (, __N1 -> __N2;)
    private static int FirstNumberPosition(string str)
    {
      List<string> counts = new List<string> { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9" };
      int pos = 0;
      for (int k = 0; k < str.Length; k++)
      {
        if (counts.Contains(str[k].ToString()))
        {
          pos = k;
          break;
        }
      }
      return pos;
    }

    // ,    line[startPos].   dot-         (, __N1 -> __N2;)
    private static string TakeNumber(int startPos, string line)
    {
      string number = "";
      for (int j = startPos; j < line.Length - 1; j++)
      {
        if (line[j].ToString() != " ")
          number += line[j].ToString();
        else
          break;
      }
      return number;
    }

    //      
    static void FillingMatrix(string line, byte[,] CFGMatrix)
    {
      int count1 = Convert.ToInt16(TakeNumber(FirstNumberPosition(line), line));
      int count2 = Convert.ToInt16(TakeNumber(SecondNumberPosition(line), line));

      CFGMatrix[count1 - 1, count2 - 1] = 1;
    }

    //     dot-,     .       
    private static string ParseDeclarationString(string statementBuffer)
    {
      var chunks =
          statementBuffer.Trim().Replace("[", "")
              .Replace("];", "")
              .Split(new char[] { ' ' }, 2);

      //name = chunks[0].Replace("__", "");

      var args = chunks[1].Split(new char[] { ',' }, StringSplitOptions.RemoveEmptyEntries);

      var foundLabel = args.FirstOrDefault(s => s.Trim().StartsWith("label"));

      return foundLabel == null ? "" : foundLabel.Replace("label=", "").Replace("\\\"", "\"").Trim('"');
    }

    // dot-.     : < >.mtr,   ,  < >.lst,   
    private static byte[,] Parser(string fileName)
    {
      string line;
      string varLine = "";

      // Read the file and display it line by line.
      StreamReader file =
          new StreamReader("src/" + fileName);

      while ((line = file.ReadLine()) != null)
      {
        if (line.IndexOf("-> __") == -1)
        {
          varLine += line;
        }
        else
          break;
      }

      string[] varList = varLine.Split(new[] { "];" }, StringSplitOptions.RemoveEmptyEntries);
      List<string> finalVarList = new List<string>();

      for (int i = 0; i < varList.Count(); i++) if (varList[i].Contains("__N"))
          finalVarList.Add(varList[i]);

      using (StreamWriter fileList = new StreamWriter("matrices/" + fileName + ".lst"))
      {
        for (int i = 0; i < finalVarList.Count; i++)
        {
          finalVarList[i] = ParseDeclarationString(finalVarList[i]);

          fileList.WriteLine(finalVarList[i]);
        }
      }

      byte[,] CFGMatrix = new byte[finalVarList.Count, finalVarList.Count];

      do
      {
        if (line.IndexOf("->") > -1)
        {
          FillingMatrix(line, CFGMatrix);
        }
      } while ((line = file.ReadLine()) != null);

      file.Close();

      for (int i = 0; i < varList.Count(); i++)
        Debug.WriteLine(varList[i]);

      return CFGMatrix;
    }

    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    [STAThread]
    static void Main()
    {
      /*
      Matrix adjMtr = new Matrix(new int[,]
      {
      // 1  2  3  4  5  6  7  8  9 10 11 12 13 14
        {0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//1
        {0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},//2
        {0, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0},//3
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0},//4
        {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0},//5
        {0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0},//6
        {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0},//7
        {0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0},//8
        {0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//9
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0},//10
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0},//11
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0},//12
        {0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//13
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0} //14
      }
        );

      Matrix domMtr = new Matrix(new int[,]
      {
      // 1  2  3  4  5  6  7  8  9 10 11 12 13 14
        {0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//1
        {0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},//2
        {0, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 1, 0},//3
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//4
        {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0},//5
        {0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0},//6
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//7
        {0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0},//8
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//9
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0},//10
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0},//11
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//12
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//13
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0} //14
      }
        );

      Matrix postdomMtr = new Matrix(new int[,]
      {
      // 1  2  3  4  5  6  7  8  9 10 11 12 13 14
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//1
        {1, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0},//2
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//3
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//4
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//5
        {0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0},//6
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//7
        {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0},//8
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//9
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},//10
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0},//11
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0},//12
        {0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0},//13
        {0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0} //14
      }
        );

      int dimension = adjMtr.Dimension;

      //    
      Matrix dominatorsMatrix = GetInitDominatorsMatrix(dimension);
      Matrix initMatrix = Matrix.GetIdentityMatrix(dimension);
      Matrix predomAdjMatrix = GetPredominatorAdjMatrix(dimension, adjMtr, dominatorsMatrix, initMatrix);
      Matrix transposedPredomMatrix = predomAdjMatrix.Transpose();
      bool isEqual1 = domMtr.Equals(transposedPredomMatrix);
      Matrix dominatorsMatrix2 = GetInitDominatorsMatrix(dimension);
      Matrix postdomAdjMatrix = GetPostdominatorAdjMatrix(dimension, adjMtr, dominatorsMatrix2, initMatrix.Transpose());
      Matrix transposedPostdomMatrix = postdomAdjMatrix.Transpose();

      Matrix postMatrix = transposedPostdomMatrix.HorizontalMapping().VerticalMapping();
      bool isEqual2 = postdomMtr.Equals(postMatrix);

      /*
      Matrix adjMtr2 = new Matrix(new int[,]
      {
      // 1  2  3  4
        {0, 1, 0, 0},//1
        {0, 0, 1, 1},//2
        {0, 0, 0, 1},//3
        {0, 0, 0, 0} //4
      }
        );

      int dimension2 = adjMtr2.Dimension;

      //    
      Matrix dominatorsMatrix2 = GetInitDominatorsMatrix(dimension2);
      Matrix initMatrix2 = Matrix.GetIdentityMatrix(dimension2);
      Matrix predomAdjMatrix2 = GetPredominatorAdjMatrix(dimension2, adjMtr2, dominatorsMatrix2, initMatrix2);
      Matrix transposedPredomMatrix2 = predomAdjMatrix2.Transpose();
      //bool isEqual12 = domMtr.Equals(transposedPredomMatrix2);
      Matrix postdomAdjMatrix2 = GetPostdominatorAdjMatrix(dimension2, adjMtr2, dominatorsMatrix2, initMatrix2);
      Matrix transposedPostdomMatrix2 = postdomAdjMatrix2.Transpose();

      Matrix postMatrix2 = transposedPostdomMatrix2.HorizontalMapping().VerticalMapping();
      

      //  
      Matrix basicBlockDominatorGraph = Matrix.Sign(Matrix.MatrixAddition(transposedPredomMatrix,
        transposedPostdomMatrix.HorizontalMapping().VerticalMapping()));

      //     
      Matrix reachabilityMatrix = Matrix.GetReachabilityMatrix(basicBlockDominatorGraph);

      //      
      Matrix strongConnectivityMatrix =
        Matrix.GetStrongConnectivityMatrix(reachabilityMatrix);

      //   
      var scBlocks = GetStronglyConnectedComponentsList(strongConnectivityMatrix);

      //       
      Matrix superBlockDominatorGraph = GetAdjMatrixForStronglyConnectedComponents(basicBlockDominatorGraph, scBlocks);
      var routes2 = SearchPaths(adjMtr);
      var routes = SearchPaths(superBlockDominatorGraph);
      */

      List<ValueTypedList<string>> lines = new List<ValueTypedList<string>>();

      string s = GetMark("MARK (RULEnode) = RULE;");

      Application.EnableVisualStyles();
      Application.SetCompatibleTextRenderingDefault(false);
      Application.Run(new MainForm());
    }

    private static List<ValueTypedList<string>> PathsSearch(Matrix matrix)
    {
      var routes = new List<ValueTypedList<string>>();

      for (int i = 0; i < matrix.Dimension; i++)
      {
        var isRowZero = matrix.IsRowZero(i);

        if (isRowZero)
        {
          routes.Add(new ValueTypedList<string>());

          routes.Last().Insert(0, i.ToString());

          var j = i;

          while (true)
          {
            if (j == 0)
            {
              break;
            }

            var col = matrix.Column(j);

            for (int k = 0; k < col.Length; k++)
            {
              if (col[k] == 1)
              {
                j = k;
                routes.Last().Insert(0, j.ToString());
                break;
              }
            }
          }
        }
      }

      return routes;
    }

    private static void PredomMatrixIteration(int dimension, Matrix adjacencyMatrix, Matrix dominatorsMatrix, Matrix initMatrix)
    {
      for (int i = 1; i < dimension; i++)
      {
        var intersection = new int[dimension];

        for (int k = 0; k < dimension; k++)
        {
          intersection[k] = 1;
        }

        for (int j = 0; j < dimension; j++)
        {
          var edge = adjacencyMatrix[j, i];

          if (edge == 1)
          {
            intersection = BitwiseAnd(intersection, dominatorsMatrix.Row(j));
          }
        }

        var dominatorRow = BitwiseOr(initMatrix.Row(i), intersection);

        dominatorsMatrix.SetRow(i, dominatorRow);
      }
    }

    private static int[] BitwiseOr(int[] a, int[] b)
    {
      var result = new int[a.Length];

      for (int i = 0; i < a.Length; i++)
      {
        result[i] = a[i] | b[i];
      }

      return result;
    }

    private static int[] BitwiseAnd(int[] a, int[] b)
    {
      var result = new int[a.Length];

      for (int i = 0; i < a.Length; i++)
      {
        result[i] = a[i] & b[i];
      }

      return result;
    }

    public static Matrix GetInitDominatorsMatrix(int dimension)
    {
      var dominatorsMatrix = new Matrix(dimension);

      for (int i = 0; i < dimension; i++)
      {
        for (int j = 0; j < dimension; j++)
        {
          if (i == 0 && j > 0)
          {
            dominatorsMatrix[i, j] = 0;
          }
          else
          {
            dominatorsMatrix[i, j] = 1;
          }
        }
      }

      return dominatorsMatrix;
    }

    private static List<string> GetFunctions(string nodeText, string procPattern)
    {
      List<String> funcNames = new List<string>();

      string pattern = @"[^\(\)\s]+\s*\([^\(\)]*\)";
      string pattern2 = @"\(.*\)";

      pattern = procPattern;

      foreach (Match item in Regex.Matches(nodeText, pattern))
      {
        funcNames.Add(item.ToString());
        //funcNames.Add(Regex.Replace(item.ToString().Trim(' '), pattern2, ""));
      }

      return funcNames;
    }

    public static Tree GetTreeByProcName(string procName)
    {
      var procFiles = Directory.GetFiles("matrices");

      var mtrFile =
          procFiles.FirstOrDefault(f => f.EndsWith(".mtr") && Path.GetFileName(f.Replace(".dot.mtr", "")).Equals(procName, StringComparison.InvariantCultureIgnoreCase));

      var adjMatrix = GetMatrixFromMtrFile(mtrFile);

      var lstFile =
          procFiles.FirstOrDefault(f => f.EndsWith(".lst") && Path.GetFileName(f.Replace(".dot.lst", "")).Equals(procName, StringComparison.InvariantCultureIgnoreCase));


      var nodeNameStrings = GetNodeNamesFromLstFile(lstFile);

      var nodeNames = new NodeNameCollection(nodeNameStrings, procName);

      var tree = new Tree(adjMatrix, nodeNames);

      return tree;
    }


    public static List<string> GetNodeNamesFromLstFile(string fileName)
    {
      var lines = File.ReadAllLines(fileName).Where(s => !String.IsNullOrEmpty(s)).ToList();

      return lines;
    }

    public static Matrix GetMatrixFromMtrFile(string fileName)
    {
      var lines = File.ReadAllLines(fileName).Where(s => !String.IsNullOrEmpty(s)).ToList();

      var result = new Matrix(lines.Count);

      for (int i = 0; i < lines.Count; i++)
      {
        var line = lines[i];

        for (int j = 0; j < line.Length; j++)
        {
          result[i, j] = Int32.Parse(line[j].ToString());
        }
      }

      return result;
    }

    //   
    public static List<List<int>> GetStronglyConnectedComponentsList(Matrix strongConnectivityMatrix)
    {
      var dimension = strongConnectivityMatrix.Dimension;

      var erasedIndexes = new HashSet<int>();

      var scBlocks = new List<List<int>>();

      while (true)
      {
        //    

        int firstRow = 0;

        bool firstRowFound = false;

        for (int i = 0; i < dimension; i++)
        {
          if (!erasedIndexes.Contains(i))
          {
            firstRow = i;

            firstRowFound = true;

            break;
          }
        }

        if (!firstRowFound)
        {
          //   .   .

          break;
        }

        //   ,    

        var scSet = new List<int>();

        for (int i = 0; i < dimension; i++)
        {
          if (strongConnectivityMatrix[firstRow, i] == 1)
          {
            if (!erasedIndexes.Contains(i))
            {
              erasedIndexes.Add(i);

              scSet.Add(i);
            }
          }
        }

        if (scSet.Any())
        {
          scBlocks.Add(scSet);
        }
        else
        {
          scSet.Add(firstRow);
          scBlocks.Add(scSet);

          erasedIndexes.Add(firstRow);
        }
      }

      return scBlocks;
    }

    //      
    public static Matrix GetAdjMatrixForStronglyConnectedComponents(Matrix basicInitialAdjMatrix, List<List<int>> scBlocks)
    {
      int scDimension = scBlocks.Count;
      var dimension = basicInitialAdjMatrix.Dimension;

      var sbMatrix = new int[scDimension, scDimension];

      for (int i = 0; i < scDimension - 1; i++)
      {
        var firstBlock = scBlocks[i];

        foreach (var comp in firstBlock)
        {
          for (int j = 0; j < dimension; j++)
          {
            if (basicInitialAdjMatrix[comp, j] == 1 && !firstBlock.Contains(j))
            {
              var linkedBlocks = scBlocks.FindAll(s => s.Contains(j));

              foreach (var linkedBlock in linkedBlocks)
              {
                var linkedBlockIndex = scBlocks.IndexOf(linkedBlock);

                sbMatrix[i, linkedBlockIndex] = 1;
              }
            }
          }
        }
      }
      return new Matrix(sbMatrix);
    }
  }
}
